//2013_1 uzduotis
#include <iostream>
#include <fstream>

using namespace std;

void skaitymas(int &n, int &km, string pavadinimas[], int atstumas[]);
void nuvaziuota(int &n, int &km, int atstumas[]);
void spausdinimas(int n, int km, string pavadinimas[]);
int kelias(int x, int y);

int main()
{
    int n, km;
    string pavadinimas[50];
    int atstumas[50];

    skaitymas(n, km, pavadinimas, atstumas);
    nuvaziuota(n, km, atstumas);
    spausdinimas(n, km, pavadinimas);

    return 0;
}

void spausdinimas(int n, int km, string pavadinimas[])
{
    ofstream fr("U1rez.txt");

    fr << n << " " << km << " " << pavadinimas[n-1];

    fr.close();
}

void nuvaziuota(int &n, int &km, int atstumas[])
{
    int kilometrai = 0;
    int aptarnauta = 0;

    for(int i = 0; i < n; i++)
    {
        if(kilometrai + atstumas[i] <= km)
        {
            kilometrai += atstumas[i];
            aptarnauta++;
        }
    }

    n = aptarnauta;
    km = kilometrai;
}

int kelias(int x, int y)
{
    return (abs(x)+abs(y))*2;
}

void skaitymas(int &n, int &km, string pavadinimas[], int atstumas[])
{
    ifstream fd("U1.txt");

    fd >> n >> km;

    for(int i = 0; i < n; i++)
    {
        fd.ignore();
        char temp[11];
        fd.get(temp, 11);
        pavadinimas[i] = temp;

        int x, y;
        fd >> x >> y;

        atstumas[i] = kelias(x,y);
    }

    fd.close();
}
